'' [][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]
'' []                                                                                []
'' []  Microchip CAP11xx driver (only tested with CAP1188 in SPI mode)               []
'' []                                                                                []
'' []  Version 1.0 (2016.09.13) -- Made driver                                       []             
'' []  Made by Anthony "TC" Conti                                                    []
'' []                                                                                []
'' [][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]

CON

{{
   [][][][][][][][][][][][][]
   []                      []
   []  CAP11xx registers   []
   []                      []
   [][][][][][][][][][][][][]
}}

Main_Control                = $00
General                     = $02
Sensor_input                = $03
LED_Status                  = $04
Noise_flag                  = $0A
Input_1_Delta               = $10
Input_2_Delta               = $11
Input_3_Delta               = $12
Input_4_Delta               = $13
Input_5_Delta               = $14
Input_6_Delta               = $15
Input_7_Delta               = $16
Input_8_Delta               = $17
Sens_Control                = $1F
Config                      = $20
Input_Enable                = $21
Input_Config_1              = $22
Input_Config_2              = $23
Ave_Samp_Config             = $24
Cal_Activate                = $26
Int_Enable                  = $27
Repeat_Enable               = $28
Mulit_touch_Config          = $2A
Multi_touch_Pattern_config  = $2B
Mulit_touch_Pattern         = $2D
Recalibration_Config        = $2F
Input_1_Threshold           = $30
Input_2_Threshold           = $31
Input_3_Threshold           = $32
Input_4_Threshold           = $33
Input_5_Threshold           = $34
Input_6_Threshold           = $35
Input_7_Threshold           = $36
Input_8_Threshold           = $37
Input_Noise_Threshold       = $38

{***  Standby Config Registers  ***}

Standby_Channel             = $40
Standby_Config              = $41
Standby_Sensitivity         = $42
Standby_Threshold           = $43
Config_2                    = $44

{***  Base Count Registers  ***}

Input_1_Count               = $50
Input_2_Count               = $51
Input_3_Count               = $52
Input_4_Count               = $53
Input_5_Count               = $54
Input_6_Count               = $55
Input_7_Count               = $56
Input_8_Count               = $57

{***  LED Controls  ***}

LED_Output_Type             = $71
Input_LED_Linking           = $72
LED_Polarity                = $73
LED_Output_Control          = $74
LED_Linked_Trans_Control    = $77
LED_Mirror_Control          = $79
LED_Behavior_1              = $81
LED_Behavior_2              = $82
LED_Pulse_1_Period          = $84
LED_Pulse_2_Period          = $85
LED_Breathe_Period          = $86
LED_Config                  = $88
LED_Pulse_1_Duty_Cycle      = $90
LED_Pulse_2_Duty_Cycle      = $91
LED_Breathe_Duty_Cycle      = $92
LED_Direct_Duty_Cycle       = $93
LED_Direct_Ramp_Rates       = $94
LED_Off_Delay               = $95

{***  Sensor Input Calibration  ***}

Sensor_1_cal                = $B1
Sensor_2_cal                = $B2
Sensor_3_cal                = $B3
Sensor_4_cal                = $B4
Sensor_5_cal                = $B5
Sensor_6_cal                = $B6
Sensor_7_cal                = $B7
Sensor_8_cal                = $B8
Sensor_cal_LSB_1            = $B9
Sensor_cal_LSB_2            = $BA

{***  Identifacation  ***}

Product_ID                  = $FD
Manufacturer_ID             = $FE
Revision                    = $FF

{{
   [][][][][][][][][][][][][]
   []                      []
   []                      []
   []                      []
   [][][][][][][][][][][][][]
}}

  SPI_cs        = 0
  wake          = 1
  SPI_mosi      = 1
  I2C_sda       = 2
  SPI_msio      = 2
  SPI_miso      = 2
  I2C_scl       = 3
  SPI_clk       = 3

  SPI_clock_delay = 5

  I2C_comm      = 0
  SPI_3_wire    = 1
  SPI_4_wire    = 2
  
  I2C_addr_0    = %0101_0000    'ADDR_COMM pin tied to VDD
  I2C_addr_1    = %0101_0010    'ADDR_COMM pin pulled to GND with 150k resistor ** default for Adafruit breakout **
  I2C_addr_2    = %0101_0100    'ADDR_COMM pin pulled to GND with 120k resistor
  I2C_addr_3    = %0101_0110    'ADDR_COMM pin pulled to GND with 100k resistor
  I2C_addr_4    = %0101_1000    'ADDR_COMM pin pulled to GND with 82k resistor

VAR

  long  IO_pin[4]
  long  alert
  long  reset
  long  mode
  byte  I2C_address
 

OBJ

  SPI   :       "SPI_ASM"
  I2C   :       "jm_i2C"        {Jon "JonnyMac" McPhalen I2C driver}  

PUB Start_I2C(scl_pin, sda_pin, alert_pin, reset_pin ) 'ADDR_COMM pulled to GND through a resistor

  IO_pin[I2C_scl] := scl_pin
  IO_pin[I2C_sda] := sda_pin
  alert := alert_pin
  reset := reset_pin

  I2C.setupx(IO_pin[I2C_scl], IO_pin[I2C_sda])

  I2C_addr_change(1)            'set to default for Adafruit breakout board

  mode := I2C_comm

PUB Start_SPI_3(cs_pin, clk_pin, data_io_pin, alert_pin, reset_pin ) 'ADDR_COMM pin pulled to GND with 56k resistor

  IO_pin[SPI_cs] := cs_pin
  IO_pin[SPI_clk] := clk_pin
  IO_pin[SPI_msio] := data_io_pin
  alert := alert_pin
  reset := reset_pin

  SPI.start(SPI_clock_delay, 0)

  mode := SPI_3_wire

PUB Start_SPI_4(cs_pin, clk_pin, data_in_pin, data_out_pin, alert_pin, reset_pin ) 'ADDR_COMM pin tied to GND

  IO_pin[SPI_cs] := cs_pin
  IO_pin[SPI_clk] := clk_pin
  IO_pin[SPI_miso] := data_in_pin
  IO_pin[SPI_mosi] := data_out_pin
  alert := alert_pin
  reset := reset_pin

  SPI.start(SPI_clock_delay, 0)

  mode := SPI_4_wire

PUB I2C_addr_change(device_address)

  case device_address
    0:  I2C_address := I2C_addr_0
    1:  I2C_address := I2C_addr_1
    2:  I2C_address := I2C_addr_2
    3:  I2C_address := I2C_addr_3
    4:  I2C_address := I2C_addr_4
  return I2C_address

PUB I2C_addr_current

  return I2C_address
  
PUB cal_sensors | i

  wr_byte(Cal_Activate, $FF)                            'start sensor calibration
  repeat i from 1 to 100                                'check up to 100 times if sensors are calibrated
    pause(100)
    if rd_byte(Cal_Activate) == $00                     'check if sensors are calibrated
      return true
       
  return rd_byte(Cal_Activate)                          'could not calibrate sensors, send back what sensor(s) could not calibrate

PUB find_device | i, x, y, z

  reset_bus

  repeat i from 1 to 100                                'try 100 times to find device
    x := rd_byte(Product_ID)                            'read product ID ($50)    
    y := rd_byte(Manufacturer_ID)                       'read manufacture ID ($5D)
    z := rd_byte(Revision)                              'read revision number
    if x == $50 AND y == $5D AND z == $83               'if everything is correct,             
      return true                                       '   return found device

  return false                                          'could not find device                        
    
PUB reset_device | i, x

  '*** reset device ***

  dira[reset] := 1
  outa[reset] := 0
  pause(100)
  outa[reset] := 1
  pause(100)
  outa[reset] := 0
  pause(100)

  return true 
  
PUB rd_byte(addr) | value

  case mode
    I2C_comm:
          value := I2C.rd_byte(I2C_address, addr)
          return value
          
    SPI_3_wire:
          CS_enable         
          set_address(addr)         
          shiftout($7F)
          value := shiftin         
          CS_disable         
          return value

    SPI_4_wire:
          CS_enable         
          set_address(addr)         
          shiftout($7F)
          value := shiftin         
          CS_disable         
          return value

PUB wr_byte(addr, value)

  case mode
    I2C_comm:
          I2C.wr_byte(I2C_address, addr, value)      

    SPI_3_wire:
          CS_enable       
          set_address(addr)       
          shiftout($7E)
          shiftout(value)       
          CS_disable
          return true      

    SPI_4_wire:
          CS_enable       
          set_address(addr)       
          shiftout($7E)
          shiftout(value)       
          CS_disable
          return true
  
PUB set_address(address)

  case mode
    I2C_comm:
          return false

    SPI_3_wire:
          shiftout($7D)
          shiftout(address)
          return true

    SPI_4_wire:
          shiftout($7D)
          shiftout(address)
          return true

PUB reset_bus

  case mode
    I2C_comm:
          return false          'not used for I2C

    SPI_3_wire:
          CS_enable       
          shiftout($7A)
          shiftout($7A)       
          CS_disable
          return true

    SPI_4_wire:
          CS_enable       
          shiftout($7A)
          shiftout($7A)       
          CS_disable
          return true
      
CON
''[][][][][][][][][][][][]
''[]                    []
''[]  Driver routines   []
''[]                    []
''[][][][][][][][][][][][]

PRI shiftout(value)

  'shift 8-bits of data out to the CAP11xx
  case mode
    SPI_3_wire:    
          SPI.SHIFTOUT(IO_pin[SPI_msio], IO_pin[SPI_clk], SPI#MSBFIRST, 8, value)   '3-wire SPI

    SPI_4_wire:
          SPI.SHIFTOUT(IO_pin[SPI_mosi], IO_pin[SPI_clk], SPI#MSBFIRST, 8, value)   '4-wire SPI

PRI shiftin | value

  'Shift 8-bits of data in from the CAP11xx
  case mode
    SPI_3_wire:
          value := SPI.SHIFTIN(IO_pin[SPI_msio], IO_pin[SPI_clk], SPI#MSBPRE, 8)    '3-wire SPI

    SPI_4_wire:
          value := SPI.SHIFTIN(IO_pin[SPI_miso], IO_pin[SPI_clk], SPI#MSBPRE, 8)    '4-wire SPI

  return value

PRI CS_enable

  'Pull chip select LOW
  dira[IO_pin[SPI_cs]] := 1
  outa[IO_pin[SPI_cs]] := 0

PRI CS_disable

  'float chip select 
  dira[IO_pin[SPI_cs]] := 0
  outa[IO_pin[SPI_cs]] := 0

PRI pause(ms) | t, mstix ' code from Jon "JonnyMac" McPhalen

  mstix    := clkfreq / 1_000                                   ' set ticks/millisecond
  t := cnt - 1168                                               ' sync with overhead correction
  repeat ms                                                       
    waitcnt(t += mstix)                                         ' wait 1ms