{Object_Title_and_Purpose}
'' 1000 face project
'' V3.0 (2016-09-14)


CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000

      
CON

  {*** PINS ***}

  {*** Audio output ***}

  Audio_Left        =   0
  Audio_Right       =   1

  {*** SD card ***}

  SD_CS             =   16
  SD_MOSI           =   17
  SD_CLK            =   18
  SD_MISO           =   19
  SD_WP             =   -1
  SD_CD             =   -1     

  {*** CAP1188 I2C ***}

  Cap_SDA           =   20
  Cap_SCL           =   22

  {*** CAP1188 SPI ***}

  Cap_MISO          =   21
  Cap_MOSI          =   20
  Cap_CLK           =   23
  Cap_CS            =   22

  {*** CAP1188 MISC ***}

  Cap_ALERT         =   25
  Cap_RESET         =   24

  {*** CAP1188 ADDRESS BUSS ***}
  Cap_BUSS_LSB      =   -1
  Cap_BUSS_MSB      =   -1

  {*** Prop ***}

  SCL               =   28
  SDA               =   29

  TX                =   30
  RX                =   31

  baud              =   115_200

  max_string_size   =   80


VAR

  long  number_chips
  long  cap_address

  
OBJ


  cap   :       "CAP1188"
  com   :       "FullDuplexSerial"
  wav   :       "V2-WAV_DACEngine"
  data  :       "SD card control"
  str   :       "jm_strings"
'  lcd   :       "ks0108v1.3"
  buss  :       "address_buss"              
  

PUB init

''/////////////////////////////////////////////////
''//                                             //
''//   Start of program. Start all the drivers   //
''//                                             //
''/////////////////////////////////////////////////

  Start_com_driver                                  ''** START SERIAL DRIVER **
  pause(1000)
 
  com.str(string("Start WAV player ------ "))       ''** START WAVE PLAYER **
  if Start_WAV_Player      'start WAV player
    com.str(string("STARTED", 13))

  else
    com.str(string("*** NOT STARTED ***"))
    repeat
  
  com.str(string("Start CAP1188 Driver -- "))       ''** START CAP1188 DRIVER **
  if Start_CAP1188_Driver
    com.str(string("STARTED", 13))

  else
    com.str(string("*** NOT STARTED ***"))

  Start_address_buss                                ''** START CAP1188 BUSS DRIVER **

  com.str(string("Address Size ---------- "))
  com.dec(address_size)
  com.tx(13) 
    
  com.str(string("Reset CAP1188 --------- "))       ''** RESET ALL CAP1188 CHIPS**
  if cap.reset_device
    com.str(string("RESET", 13))

  else
    com.str(string("*** DID NOT RESET ***"))

  Main                                              ''** START MAIN CODE **

PUB Main | i

''///////////////////
''//               //
''//   Main code   //
''//               //
''///////////////////

  com.str(string("How many CAP1188 ------ "))
  number_chips := 0
  repeat i from 0 to address_size
    buss.address(i)
    if cap.Find_device
        number_chips := number_chips + 1    

  if number_chips > 0
    com.dec(number_chips)
    com.str(string(" WERE FOUND", 13))

  else
    com.str(string("NONE WERE FOUND", 13))
  

  com.str(string("Mount SD card --------- "))
  if data.Mount_Partition
    com.str(string("MOUNTED", 13))

  else
    com.str(string("*** DID NOT MOUNT ***", 13))

  Find_master

'  New_File(@master_config, 5, csv_format)

    
{
  Check_Master_File     'check for master config file. If there is no file, make one

  com.str(string("Load registers from SD card", 13))
  Load_from_file(@Master_config)
}


 
  com.str(string(13, 13, "done"))

'  displayX(@@dia_screen)
  
PUB Find_master

  com.str(string("Find Master File ------ "))
  if Find_file(@master_config)
    com.str(string("MASTER FILE FOUND", 13))

  else
        com.str(string("FILE NOT FOUND", 13))
        com.str(string("CREATE MASTER FILE ---- "))
        if New_file(@master_config, -1, @csv_format)
            com.str(string("FILE CREATED", 13))
            com.str(string("WRITING FILE ------ "))
            wr_file_sd(@master_config, @config, @config_lines)
            com.str(string("DONE", 13))
         
        else
            com.str(string("** COULD NOT CREATE", 13))    
    
  
CON

''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]
''[]                                                                                            []
''[]  CAP1188 CONTROL CODE                                                                      []
''[]                                                                                            []
''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]

VAR

  byte  registers[100]
  
PRI Load_from_file(file_name) | len

''///////////////////////////////////////////////////////////////////
''//                                                               //
''//   Reads values from the SD card, and loads them to the chip   //
''//                                                               //
''///////////////////////////////////////////////////////////////////

  data.Read_file(File_Name)
  repeat                                                        ' read the file
    len := read_string
    if (len < 5)                                                ' shortest legal line is 0,0,0
      quit
    else
      extract_parameters(2)

    cap.wr_byte(extract_value[0], extract_value[1])
            
  data.close_file

CON

''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]
''[]                                                                                            []
''[]  FILE DATA EXTRACTION                                                                      []
''[]                                                                                            []
''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]

VAR

  byte      String_Buffer[200]
  byte      parambuf[16]
  byte      extract_value[16]
  
PRI read_string | len

''/////////////////////////////////////////
''//                                     //
''//   Reads a string from the SD card   //
''//                                     //
''/////////////////////////////////////////

  bytefill(@String_Buffer, 0, 200)
  len := data.Read_str(@String_Buffer)  
  return len

PRI read_cfg_file(file_name) | len

''//////////////////////////////////////////////////////
''//                                                  //
''//   Read configuration file, and extracts values   //
''//                                                  //
''//////////////////////////////////////////////////////

  data.Read_file(File_Name)
  repeat                                                        ' read the file
    len := read_string
    if (len < 5)                                                ' shortest legal line is 0,0,0
      quit
    else
      extract_parameters(2)
  data.close_file                                 
  
PRI extract_parameters(number_of_fields) | field, p_field, value[3]

''///////////////////////////////////////////
''//                                       //
''//   Extracts values from a CSV string   //
''//                                       //
''///////////////////////////////////////////

  str.replace(10, 0, @String_Buffer)                        ' clean-up line end
  str.replace(13, 0, @String_Buffer)  

  repeat field from 0 to number_of_fields - 1                                      
    p_field := str.field_pntr(@String_Buffer, field, ",")   ' find field in line    
    str.copy_field(@parambuf, p_field, ",", 15)             ' copy field from line    
    str.trim(@parambuf)                                         ' remove extra spaces
    if (str.is_number(@parambuf))                            
        extract_value[field] := str.asc2val(@parambuf)      ' <-- extraction is here!
      
    else
        quit

CON

''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]
''[]                                                                                            []
''[]  SD CARD AND FILE CONTROL                                                                  []
''[]                                                                                            []
''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]

PRI Find_File (File_Name)

''/////////////////////////////////////////////////////////
''//                                                     //
''//   Finds a file, and returns "TRUE" if it is found   //
''//                                                     //
''/////////////////////////////////////////////////////////
   com.str(File_name)
   com.dec(data.read_file(File_name))
  if data.Find_File(File_Name)
    com.tx("@")
    return true

  else
    
    return false

PRI wr_str_SD(string_list)

''////////////////////////////////////////
''//                                    //
''//   Writes a string to the SD card   //
''//                                    //
''////////////////////////////////////////

  data.Write_str(string_list)

PRI wr_file_sd(string_pointer, string_list, lines) | index

''///////////////////////////////////////
''//                                   //
''//   Writes string data to SD card   //
''//                                   //
''///////////////////////////////////////

  data.Write_file(string_pointer)

  
  repeat index from 0 to lines
    data.Write_str(string_list)

  data.close_file

pub New_File(string_pointer, number, format) | string_temp, c, i

  repeat strsize(string_pointer)
    c := byte[string_pointer++]
    if c <> 0
        byte[string_temp++] := c

  
  if number <> -1
    i := 1_000_000_000                                    'Initialize divisor
     
    repeat 10                                             'Loop for 10 digits
      if number => i                                                               
        byte[string_temp++] := (number / i + "0")      'If non-zero digit, output digit; adjust for max negative
        number //= i                                      'and digit from value
        result~~                                          'flag non-zero found
      elseif result or i == 1
        byte[string_temp++] := "0"                                           'If zero digit (or only digit) output it
      i /= 10                                             'Update divisor

  repeat strsize(format)
    c := byte[format++]
    if c <> 0 
        byte[string_temp++] := c

  byte[string_temp] := 0

'  com.str(string("File Name --   "))
'  com.str(string_temp)
'  com.tx(13)

  Check_Master_File '***** TEMP for checking *****

  return true
        
PRI Check_Master_File | i

''//////////////////////////////////////////////////////////////////////////
''//                                                                      //
''//   Checks to see if the Master configruition file is on the SD-card   //
''//   If master configurition file was not found, create file            //
''//                                                                      //
''//////////////////////////////////////////////////////////////////////////

  

  if data.New_file(@Master_config)      'Try to make master config file
'    com.str(string("Master config file was not detected"))
    data.Write_File(@Master_config)     'No master config file found?.. make one 
    
'    repeat i from 0 to config_lines               'write master config data to SD card
'        data.Write_str(@@config[i])
        
'    com.str(string(" --- Master config file was created", 13))

    data.Close_file
    
  else                                  'master config file was found
  
'    com.str(string("Master config file was detected", 13))

CON

''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]
''[]                                                                                            []
''[]  SERIAL TERMINAL CONTROL                                                                   []
''[]                                                                                            []
''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]

PRI displayX(string_pointer)

''//////////////////////////////
''//                          //
''//   For "DAT" block only   //
''//                          //
''//////////////////////////////

  display(byte[string_pointer], byte[string_pointer + 1], string_pointer + 2)  
  
PRI display(x, y, Display_string)

''////////////////////////////////////////////////////////
''//                                                    //
''//   For displaying information on terminal screen    //
''//                                                    //
''//   x = number of places from top, starting at 0     //
''//   y = number of places from left, starting at 0    //
''//   Display_string = string of letters and/or data   //
''//                                                    //
''////////////////////////////////////////////////////////

  move(x, y)
  com.str(Display_string)

PRI move(x,y)

''////////////////////////////////////////////////////////
''//                                                    //
''//   For moving cursor on serial terminal screen      //
''//                                                    //
''//   x = number of places from top, starting at 0     //
''//   y = number of places from left, starting at 0    //
''//                                                    //
''////////////////////////////////////////////////////////

  com.tx(2) 'move command
  com.tx(y)
  com.tx(x)

CON

''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]
''[]                                                                                            []
''[]  CODE TO START DRIVERS                                                                     []
''[]                                                                                            []
''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]

VAR

  long  address_size
  
PRI Start_com_driver

''////////////////////////////////////////////////
''//                                            //
''//   Starts the serial communication driver   //
''//                                            //
''////////////////////////////////////////////////

  com.Start(rx, tx, 0, baud)
  return true

PRI Start_CAP1188_driver

''/////////////////////////////////////////
''//                                     //
''//   Starts the CAP1188 touch sensor   //
''//                                     //
''/////////////////////////////////////////

  cap.Start_SPI_4(Cap_CS, Cap_CLK, Cap_MISO, Cap_MOSI, Cap_ALERT, Cap_RESET )
  return true
  
PRI Start_WAV_Player

''/////////////////////////////////////
''//                                 //
''//   Starts the WAV audio player   //
''//                                 //
''/////////////////////////////////////

  if(wav.begin(Audio_Left, Audio_Right, SD_MISO, SD_CLK, SD_MOSI, SD_CS, SD_WP, SD_CD))
    return true
   
  else
    return false

PRI Start_address_buss | i 

''/////////////////////////////////////////
''//                                     //
''//   Starts address buss for CAP1188   //
''//                                     //
''/////////////////////////////////////////
  
  
  i := buss.start(Cap_buss_LSB, Cap_buss_MSB)   ''returns number of pins used
  case i
    0:  address_size := 0
    1:  address_size := 1 
    2:  address_size := 3
    3:  address_size := 7
    4:  address_size := 15
    5:  address_size := 31
    6:  address_size := 63
    7:  address_size := 127
    8:  address_size := 255
    9:  address_size := 511
    10: address_size := 1023

PRI two_comp(value, x, y)
 
  move(x,y)

  if value & (1<<7)
    com.str(string("    "))
    move(x,y)
    com.tx("-")
    value := (!value) + 1
    com.dec(value)

  else
    com.str(string("    "))
    move(x,y)
    com.dec(value)
    
CON

''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]
''[]                                                                                            []
''[]  MATH CODE                                                                                 []
''[]                                                                                            []
''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]

PRI null

CON

''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]
''[]                                                                                            []
''[]  DELAY CODE                                                                                []
''[]                                                                                            []
''[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]

PRI pause(ms) | t, mstix ' code from Jon "JonnyMac" McPhalen

  mstix    := clkfreq / 1_000                                   ' set ticks/millisecond
  t := cnt - 1168                                               ' sync with overhead correction
  repeat ms                                                       
    waitcnt(t += mstix)                                         ' wait 1ms

DAT

''////////////////////
''//                //
''//   File names   //
''//                //
''////////////////////

Master_config   byte    "_MASTER.CSV", 0

csv_format      byte    ".CSV", 0

sensor_file     byte    "SENSOR_", 0



''/////////////////////////////////////////////
''//                                         //
''//   Serial termimal display information   //
''//                                         //
''/////////////////////////////////////////////

dia_screen      long    @header

header          byte    10, 0, "Sensor Diag"



''/////////////////////////////////////
''//                                 //
''//   Data for master config file   //
''//                                 //
''/////////////////////////////////////
config_lines    long    47

config          long    @configHead
                long    @config1
                long    @config2
                long    @config3
                long    @config4
                long    @config5
                long    @config6
                long    @config7
                long    @config8
                long    @config9
                long    @config10
                long    @config11
                long    @config12
                long    @config13
                long    @config14
                long    @config15
                long    @config16
                long    @config17
                long    @config18
                long    @config19
                long    @config20
                long    @config21
                long    @config22
                long    @config23
                long    @config24
                long    @config25
                long    @config26
                long    @config27
                long    @config28
                long    @config29
                long    @config30
                long    @config31
                long    @config32
                long    @config33
                long    @config34
                long    @config35
                long    @config36
                long    @config37
                long    @config38
                long    @config39
                long    @config40
                long    @config41
                long    @config42
                long    @config43
                long    @config44
                long    @config45
                long    @config46
            
                                                            
config1     byte    "$00, $E0, Main Control",                                       13, 10, 0   'O
config2     byte    "$1F, $2F, Sensitivity Control",                                13, 10, 0   'O
config3     byte    "$20, $A8, Configuration",                                      13, 10, 0
config4     byte    "$21, $00, Sensor Input Enable",                                13, 10, 0   'O
config5     byte    "$22, $54, Sensor Input Configuration",                         13, 10, 0
config6     byte    "$23, $07, Sensor Input Configuration 2",                       13, 10, 0
config7     byte    "$24, $39, Averaging and Sampling Config",                      13, 10, 0
config8     byte    "$26, $00, Calibration Activate",                               13, 10, 0
config9     byte    "$27, $FF, Interrupt Enable",                                   13, 10, 0
config10    byte    "$28, $FF, Repeat Rate Enable",                                 13, 10, 0
config11    byte    "$2A, $80, Multiple Touch Configuration",                       13, 10, 0
config12    byte    "$2B, $00, Multiple Touch Pattern Configuration",               13, 10, 0
config13    byte    "$2D, $FF, Multiple Touch Pattern",                             13, 10, 0
config14    byte    "$2F, $8A, Recalibration Configuration",                        13, 10, 0
config15    byte    "$30, $40, Sensor Input 1 Threshold",                           13, 10, 0
config16    byte    "$31, $40, Sensor Input 2 Threshold",                           13, 10, 0
config17    byte    "$32, $40, Sensor Input 3 Threshold",                           13, 10, 0
config18    byte    "$33, $40, Sensor Input 4 Threshold",                           13, 10, 0
config19    byte    "$34, $40, Sensor Input 5 Threshold",                           13, 10, 0
config20    byte    "$35, $40, Sensor Input 6 Threshold",                           13, 10, 0
config21    byte    "$36, $40, Sensor Input 7 Threshold",                           13, 10, 0
config22    byte    "$37, $40, Sensor Input 8 Threshold",                           13, 10, 0
config23    byte    "$38, $01, Sensor Input Noise Threshold",                       13, 10, 0
config24    byte    "$40, $FF, Standby Channel",                                    13, 10, 0
config25    byte    "$41, $38, Standby Configuration",                              13, 10, 0
config26    byte    "$42, $01, Standby Sensitivity",                                13, 10, 0
config27    byte    "$43, $40, Standby Threshold",                                  13, 10, 0
config28    byte    "$44, $40, Configuration 2",                                    13, 10, 0
config29    byte    "$71, $00, LED Output Type",                                    13, 10, 0
config30    byte    "$72, $FF, Sensor Input LED Linking",                           13, 10, 0
config31    byte    "$73, $00, LED Polarity",                                       13, 10, 0
config32    byte    "$74, $00, LED Output Control",                                 13, 10, 0
config33    byte    "$77, $00, LED Linked Transition Control",                      13, 10, 0
config34    byte    "$79, $00, LED Mirror Control",                                 13, 10, 0
config35    byte    "$81, $00, LED Behavior 1",                                     13, 10, 0
config36    byte    "$82, $00, LED Behavior 2",                                     13, 10, 0
config37    byte    "$84, $20, LED Pulse 1 Period",                                 13, 10, 0
config38    byte    "$85, $14, LED Pulse 2 Period",                                 13, 10, 0
config39    byte    "$86, $5D, LED Breathe Period",                                 13, 10, 0
config40    byte    "$88, $04, LED Config",                                         13, 10, 0
config41    byte    "$90, $F0, LED Pulse 1 Duty Cycly",                             13, 10, 0
config42    byte    "$91, $F0, LED Pulse 2 Duty Cycle",                             13, 10, 0
config43    byte    "$92, $F0, LED Breathe Duty Cycle",                             13, 10, 0
config44    byte    "$93, $F0, LED Direct Duty Cycle",                              13, 10, 0
config45    byte    "$94, $00, LED Direct Ramp Rates",                              13, 10, 0
config46    byte    "$95, $00, LED Off Delay",                                      13, 10, 0
configHead  byte    "REGISTER,VALUE,DISCRIPTION",                                   13, 10, 0


''///////////////////////////////////////////
''//                                       //
''//   Data for indavidual CAP1188 chips   //
''//                                       //
''///////////////////////////////////////////
sensor_coun byte    15

sensor_conf long    @sensor_head
            long    @sensor_num
            long    @blank1
            long    @blank2
            long    @sensor_disc
            long    @gain
            long    @delta_sence
            long    @base_shift
            long    @sensor1_en
            long    @sensor2_en
            long    @sensor3_en
            long    @sensor4_en
            long    @sensor5_en
            long    @sensor6_en
            long    @sensor7_en
            long    @sensor8_en

sensor_head byte    "Use datasheet, to determine, what values to are needed",           13, 10, 0
sensor_num  byte    "This file is, for only chip, number ",                             13, 10, 0
blank1      byte    "   ,   ,   ",                                                      13, 10, 0
blank2      byte    "   ,   ,   ",                                                      13, 10, 0
sensor_disc byte    "SETTING, VALUE, ALLOWED VALUES - default is stared",               13, 10, 0
gain        byte    "GAIN, 1, [*1*] [2] [4] [8]",                                       13, 10, 0
delta_sence byte    "SENSITIVITY, 32, [1] [2] [4] [8] [16] [*32*] [64] [128]",          13, 10, 0
base_shift  byte    "BASE SHIFT, 256, [1] [2] [4] [8] [16] [*32*] [64] [128] [256]",    13, 10, 0
sensor1_en  byte    "SENSOR 1, ENABLED, [*ENABLED*] [DISABLED]",                        13, 10, 0
sensor2_en  byte    "SENSOR 2, ENABLED, [*ENABLED*] [DISABLED]",                        13, 10, 0
sensor3_en  byte    "SENSOR 3, ENABLED, [*ENABLED*] [DISABLED]",                        13, 10, 0
sensor4_en  byte    "SENSOR 4, ENABLED, [*ENABLED*] [DISABLED]",                        13, 10, 0
sensor5_en  byte    "SENSOR 5, ENABLED, [*ENABLED*] [DISABLED]",                        13, 10, 0
sensor6_en  byte    "SENSOR 6, ENABLED, [*ENABLED*] [DISABLED]",                        13, 10, 0
sensor7_en  byte    "SENSOR 7, ENABLED, [*ENABLED*] [DISABLED]",                        13, 10, 0
sensor8_en  byte    "SENSOR 8, ENABLED, [*ENABLED*] [DISABLED]",                        13, 10, 0

''/////////////////////////////////////
''//                                 //
''//   Data for audio file linking   //
''//                                 //
''/////////////////////////////////////
audio_count byte    3

audio_link  long    @link_head1
            long    @link_head2
            long    @link_blank
            long    @link_disc

link_head1  byte    "Only change, file name in AUDIO FILE column",                      13, 10, 0
link_head2  byte    "**DO NOT CHANGE, ANY PART OF FIRST COLUMN**",                      13, 10, 0
link_blank  byte    "            ,                              ",                      13, 10, 0
link_disc   byte    "SENSOR NUMBER, AUDIO FILE NAME [0000.WAV] -- [1000.WAV]",          13, 10, 0 
             